#include <engine/2d/trigger.h>

/*
 * trigger_init:
 *	Initializes the members of a AreaTrigger struct.
 */
void
trigger_init(p_trigger, callback, is_debug, x, y, w, h)
struct AreaTrigger *p_trigger;
void (*callback)();
int is_debug;
short x, y, w, h;
{
	p_trigger->is_debug = 1;
	p_trigger->callback = callback;

	SetTile(&p_trigger->tile);

	/* turn semi-transparency on */
	SetSemiTrans(&p_trigger->tile, 1);

	setRGB0(&p_trigger->tile, 68, 128, 128); /* light blue */
	setXY0(&p_trigger->tile, x, y);
	setWH(&p_trigger->tile, w, h);
}

/*
 * trigger_check:
 *	Checks whether the marker is within the trigger's area.
 */
trigger_check(p_trigger, p_marker)
struct AreaTrigger *p_trigger;
VECTOR *p_marker;
{
	short x = p_trigger->tile.x0;
	short y = p_trigger->tile.y0;
	short w = p_trigger->tile.w;
	short h = p_trigger->tile.h;

	if( ((p_marker->vx > x) && (p_marker->vx < x+w)) &&
		( (p_marker->vy > y) && (p_marker->vy < y+h)))
	{
		p_trigger->callback();
	}
}

/*
 * trigger_draw:
 *	Draws the trigger's debug members.
 */
trigger_draw(p_trigger)
struct AreaTrigger *p_trigger;
{
	if(p_trigger->is_debug)
	{
		DrawPrim(&p_trigger->tile);
	}
}

